
SWEP.Base 				= "umbrella_base_shotgun"
SWEP.Instructions			= "Uses 12 Gauge Buckshot, Alternate Mode: E + Right Click"
SWEP.Spawnable			= false
SWEP.AdminSpawnable		= true
SWEP.ViewModelFlip		= false
SWEP.ViewModel 			= "models/weapons/v_shot_dbarel.mdl"
SWEP.WorldModel 		= "models/weapons/w_shot_dbarel.mdl"

SWEP.HoldType				= "ar2"
SWEP.Primary.Sound 		= Sound("Weapon_dbarel.Single")
SWEP.Primary.Recoil 		= 10
SWEP.Primary.Damage 		= 4.6
SWEP.Primary.NumShots 		= 20
SWEP.Primary.Cone 		= 0.07
SWEP.Primary.ClipSize 		= 2
SWEP.Primary.Delay 		= 0.00000000001
SWEP.Primary.DefaultClip 	= 2
SWEP.Primary.Automatic 		= false
SWEP.Primary.Ammo 		= "buckshot"

SWEP.Secondary.ClipSize 	= -1
SWEP.Secondary.DefaultClip 	= -1
SWEP.Secondary.Automatic 	= false
SWEP.Secondary.Ammo 		= "none"

SWEP.IronSightsPos = Vector (-2.7682, -4.4406, 1.6279)
SWEP.IronSightsAng = Vector (0.759, 0.086, 0)

SWEP.Pistol				= false
SWEP.Rifle				= false
SWEP.Shotgun			= true
SWEP.Sniper				= false

SWEP.RunArmOffset  = Vector (5.4116, -0.2814, 0.9555)
SWEP.RunArmAngle   = Vector (-13.1704, 36.9575, -3.0763)

SWEP.Burst				= true
SWEP.BurstShots			= 2
SWEP.BurstDelay			= 0.000000000000001
SWEP.BurstCounter			= 0
SWEP.BurstTimer			= 0

SWEP.Type				= 3
SWEP.Mode				= true

SWEP.data 				= {}
SWEP.data.NormalMsg		= "Switched to Single Shot"
SWEP.data.ModeMsg			= "Switched to Both Shots."
SWEP.data.Delay			= 0.5
SWEP.data.Cone			= 1
SWEP.data.Damage			= 1
SWEP.data.Recoil			= 1

SWEP.ShotgunReloading		= true
SWEP.ShotgunFinish		= 2.0
SWEP.ShotgunBeginReload		= 1.0



/*---------------------------------------------------------
   Name: SWEP:Think()
   Desc: Called every frame.
---------------------------------------------------------*/
function SWEP:Think()
	if self.Weapon:Clip1() > self.Primary.ClipSize then
		self.Weapon:SetClip1(self.Primary.ClipSize)
	end
	
	if self.Weapon:GetNetworkedBool("Reloading") == true then
		if self.Weapon:GetNetworkedInt("ReloadTime") < CurTime() then
			if (self.Weapon:Clip1() >= self.Primary.ClipSize or self.Owner:GetAmmoCount(self.Primary.Ammo) <= 0) then
				self.Weapon:SetNextPrimaryFire(CurTime() + 2.0)
				self.Weapon:SetNextSecondaryFire(CurTime() + 2.0)
				self.Weapon:SetNetworkedBool( "reloading", false)
				self.Weapon:SendWeaponAnim(ACT_SHOTGUN_RELOAD_FINISH)

				if (IsValid(self.Owner) and self.Owner:GetViewModel()) then
					self:IdleAnimation(self.Owner:GetViewModel():SequenceDuration())
				end
			else
				self.Weapon:SetNetworkedInt("ReloadTime", CurTime() + 1.0)
				self.Weapon:SendWeaponAnim(ACT_VM_RELOAD)
				self.Owner:RemoveAmmo(1, self.Primary.Ammo, false)
				self.Weapon:SetClip1(self.Weapon:Clip1() + 1)
				self.Weapon:SetNextPrimaryFire(CurTime() + 2.0)
				self.Weapon:SetNextSecondaryFire(CurTime() + 2.0)

				if (self.Weapon:Clip1() >= self.Primary.ClipSize or self.Owner:GetAmmoCount(self.Primary.Ammo) <= 0) then
					self.Weapon:SetNextPrimaryFire(CurTime() + 2.5)
					self.Weapon:SetNextSecondaryFire(CurTime() + 2.5)
				else
					self.Weapon:SetNextPrimaryFire(CurTime() + 2.5)
					self.Weapon:SetNextSecondaryFire(CurTime() + 2.5)
				end
			end
		end
	end


	self:SecondThink()

	if self.IdleDelay < CurTime() and self.IdleApply and self.Weapon:Clip1() > 0 then
		local WeaponModel = self.Weapon:GetOwner():GetActiveWeapon():GetClass()

		if self.Weapon:GetOwner():GetActiveWeapon():GetClass() == WeaponModel and self.Owner:Alive() then
			if self.Weapon:GetDTBool(3) and self.Type == 2 then
				self.Weapon:SendWeaponAnim(ACT_VM_IDLE_SILENCED)
			else
				self.Weapon:SendWeaponAnim(ACT_VM_IDLE)
			end

			if self.AllowPlaybackRate and not self.Weapon:GetDTBool(1) then
				self.Owner:GetViewModel():SetPlaybackRate(1)
			else
				self.Owner:GetViewModel():SetPlaybackRate(0)
			end	
		end

		self.IdleApply = false
	elseif self.Weapon:Clip1() <= 0 then
		self.IdleApply = false
	end

	if self.Weapon:GetDTBool(1) and self.Owner:KeyDown(IN_SPEED) then
		self:SetIronsights(false)
	end

	// If you're running or if your weapon is holsted, the third person animation is going to change
	if self.Owner:KeyDown(IN_SPEED) or self.Weapon:GetDTBool(0) then
		if self.Rifle or self.Sniper or self.Shotgun then
			self:SetWeaponHoldType("passive")
		
		elseif self.Pistol then
			self:SetWeaponHoldType("normal")
		end
		
	else
		self:SetWeaponHoldType(self.HoldType)
	end

	// Burst fire mode
	if self.Weapon:GetDTBool(3) and self.Type == 3 then
		if self.BurstTimer + self.BurstDelay < CurTime() then
			if self.BurstCounter > 0 then
				self.BurstCounter = self.BurstCounter - 1
				self.BurstTimer = CurTime()
				
				if self:CanPrimaryAttack() then
					self.Weapon:EmitSound(self.Primary.Sound)
					self:ShootBulletInformation()
					self:TakePrimaryAmmo(1)
				end
			end
		end
	end

	self:NextThink(CurTime())
end
/*---------------------------------------------------------
   Name: SWEP:Reload()
   Desc: Reload is being pressed.
---------------------------------------------------------*/
function SWEP:Reload()

	if (self.ActionDelay > CurTime()) then return end 

	if (self.Weapon:GetNWBool("Reloading") or self.ShotgunReloading) then return end

	if (self.Weapon:Clip1() < self.Primary.ClipSize and self.Owner:GetAmmoCount(self.Primary.Ammo) > 0) then
		self.ShotgunReloading = true
		self.Weapon:SetNextPrimaryFire(CurTime() + self.ShotgunBeginReload + 2.0)
		self.Weapon:SetNextSecondaryFire(CurTime() + self.ShotgunBeginReload + 2.0)
		self.Weapon:SendWeaponAnim(ACT_SHOTGUN_RELOAD_START)
			
		if ( self.Weapon:Clip1() < 2 ) then
				timer.Create( "reloading1", 0.55, 1, function()
				local effectdata = EffectData()  
				effectdata:SetEntity(self.Weapon)  
				effectdata:SetAttachment(self.Weapon:LookupAttachment("4")) 
				effectdata:SetScale(8)  
				util.Effect("effect_umb_shell_shotguns", effectdata, true, true)
				end )
			end
			if ( self.Weapon:Clip1() < 1 ) then
				timer.Create( "reloading2", 0.55, 1, function()
				local effectdata = EffectData()  
				effectdata:SetEntity(self.Weapon)  
				effectdata:SetAttachment(self.Weapon:LookupAttachment("3")) 
				effectdata:SetScale(8)  
				util.Effect("effect_umb_shell_shotguns", effectdata, true, true)
				end )
			end

		timer.Simple(self.ShotgunBeginReload, function()
			self.ShotgunReloading = false
			self.Weapon:SetNetworkedBool("Reloading", true)
			self.Weapon:SetVar("ReloadTime", CurTime() + 2.0)
			self.Weapon:SetNextPrimaryFire(CurTime() + 2.0)
			self.Weapon:SetNextSecondaryFire(CurTime() + 2.0)
		end)

		if (SERVER) then
			self.Owner:SetFOV( 0, 0.15 )
			self:SetIronsights(false)
		end
	end
end

/*---------------------------------------------------------
   Name: SWEP:Deploy()
   Desc: Whip it out.
---------------------------------------------------------*/
function SWEP:Deploy()

	self.ShotgunReloading = false
	self.Weapon:SetNetworkedBool("Reloading", false)

	self.Weapon:SendWeaponAnim(ACT_VM_DRAW)

	self.Weapon:SetNextPrimaryFire(CurTime() + self.DeployDelay)
	self.Weapon:SetNextSecondaryFire(CurTime() + self.DeployDelay)
	self.ActionDelay = (CurTime() + self.DeployDelay)

	if (SERVER) then
		self:SetIronsights(false)
	end

	if (IsValid(self.Owner) and self.Owner:GetViewModel()) then
		self:IdleAnimation(self.Owner:GetViewModel():SequenceDuration())
	end

	return true
end

/*---------------------------------------------------------
   Name: SWEP:ShootAnimation()
---------------------------------------------------------*/
function SWEP:ShootAnimation()
		
	if ( self.Weapon:Clip1() == 1 ) then
	self.Weapon:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	self.ShellEffect = ""
	end

	if ( self.Weapon:Clip1() == 0 ) then
	self.Weapon:SendWeaponAnim(ACT_VM_PRIMARYATTACK)
	self.ShellEffect = ""
	end
end



